import { Component, ViewChild } from '@angular/core';
import {Nav, Platform} from 'ionic-angular';
import { StatusBar } from '@ionic-native/status-bar';
import { SplashScreen } from '@ionic-native/splash-screen';


import {AuthService} from '../providers/auth-service';
import {LocalStorage} from "../providers/localStorage";

import { HomePage } from '../pages/home/home';
import {LoginPage} from "../pages/login/login";
import {ProfilPage} from "../pages/profil/profil";
import {UserService} from "../providers/user-service";
import { TchatPage } from '../pages/tchat/tchat';


@Component({
  templateUrl: 'app.html'
})
export class MyApp {
  @ViewChild(Nav) nav: Nav;


  rootPage: any;

  pages: Array<{title: string, component: any}>;

  constructor(public platform: Platform, public statusBar: StatusBar, public splashScreen: SplashScreen,
              public auth: AuthService, public storage: LocalStorage, public user: UserService) {
    this.initializeApp();
console.log("init app");
      this.storage.getEmail().then(email=> {
          if (email == null)
              this.rootPage = LoginPage;

          else{
              this.rootPage = HomePage;
              console.log('ici'+this.storage.getUser());

          }

      })


    // used for an example of ngFor and navigation
    this.pages = [
      { title: 'Accueil', component: HomePage },
        { title: 'Chats', component: TchatPage },
        { title: 'Mon compte', component: ProfilPage }
    ];

  }

  initializeApp() {
    this.platform.ready().then(() => {
      // Okay, so the platform is ready and our plugins are available.
      // Here you can do any higher level native things you might need.
      this.statusBar.styleDefault();
      this.splashScreen.hide();
    });
  }

  openPage(page) {
    // Reset the content nav to have just this page
    // we wouldn't want the back button to show in this scenario
    this.nav.setRoot(page.component);
  }
  logout(){
    this.storage.removeEmail();
    //this.storage.clearStorage()
    this.auth.logout().subscribe(succ=>{
      this.nav.setRoot(LoginPage)
    })
  }

}
