import { BrowserModule } from '@angular/platform-browser';
import { ErrorHandler, NgModule } from '@angular/core';
import { IonicApp, IonicErrorHandler, IonicModule } from 'ionic-angular';

import { HttpModule} from '@angular/http';


import { MyApp } from './app.component';
import {HomePageModule} from "../pages/home/home.module";
import { ListPage } from '../pages/list/list';
import { LoginPageModule} from '../pages/login/login.module';
import {ProfilPageModule} from "../pages/profil/profil.module";
import {TchatPageModule} from "../pages/tchat/tchat.module";
import {MessageTchatPageModule} from "../pages/message-tchat/message-tchat.module";


import { StatusBar } from '@ionic-native/status-bar';
import { SplashScreen } from '@ionic-native/splash-screen';
import {AuthService} from "../providers/auth-service";
import {LocalStorage} from "../providers/localStorage";
import {IonicStorageModule} from "@ionic/storage";

import {UserService} from "../providers/user-service";
import {MatrixService } from '../providers/matrix-service';
import {PipesModule} from '../pipes/pipes.module';

import {AgmCoreModule } from '@agm/core';
import {Geolocation} from "@ionic-native/geolocation";
import {GoogleMaps} from "../providers/google-maps";

@NgModule({
  declarations: [
    MyApp,
    ListPage,
  ],
  imports: [
    BrowserModule,
    IonicModule.forRoot(MyApp),
      IonicStorageModule.forRoot(),
      HttpModule,
      AgmCoreModule.forRoot({
        apiKey: 'AIzaSyCsThrYLtyTXUa5gkYdCh-d1yR221u3BXI'
    }),
      LoginPageModule,
      MessageTchatPageModule,
      ProfilPageModule,
      TchatPageModule, 
      PipesModule,
      HomePageModule
  ],
  bootstrap: [IonicApp],
  entryComponents: [
    MyApp,
    ListPage
  ],
  providers: [
    StatusBar,
    SplashScreen,
    {provide: ErrorHandler, useClass: IonicErrorHandler},
      AuthService,
      LocalStorage,
      UserService,
      GoogleMaps,
      Geolocation,
      MatrixService
  ]
})
export class AppModule {}
