<?php
ini_set("display_errors",0);error_reporting(0);
use Slim\Http\Request;
use Slim\Http\Response;

// Routes

/*$app->get('/[{name}]', function (Request $request, Response $response, array $args) {
    // Sample log message
    $this->logger->info("Slim-Skeleton '/' route");

    // Render index view
    return $this->renderer->render($response, 'index.phtml', $args);
});*/


// authentification users
$app->post('/auth', function ($request, $response) {
    $input = $request->getParsedBody();
    $sth = $this->db->prepare("SELECT id, nom, prenom, email, tel 
                                FROM users 
                                WHERE email=:email and mdp =:mdp");
    $sth->bindParam("email", $input['login']);
    $sth->bindParam("mdp", $input['password']);
    $sth->execute();
    $result = $sth->fetchObject();
    if (!$result)
        return $this->response->withJson('Not Found');
    return $this->response->withJson($result);
});

// authentification users
$app->get('/authMobile[/{email}[/{password}]]', function ($request, $response, $args) {
    $input = $request->getParsedBody();
    
    $sth = $this->db->prepare("SELECT *
                                FROM usersmobile 
                                WHERE email=:email and mdp =:mdp");
    $sth->bindParam("email", $args['email']);
    $sth->bindParam("mdp", $args['password']);
    $sth->execute();
    $result = $sth->fetchObject();
    if (!$result)
        return $this->response->withJson(array("status" => "error", "code" => 0));
    return $this->response->withJson($result);
});


/*streaming*/
$app->get('/streaming/[{apikey}]', function ($request, $response, $args) {
    $service_url = 'https://matrix.org:8448/_matrix/client/r0/sync?filter={"room":{"timeline":{"limit":1}}}&access_token='.$args['apikey'];
    $headers = array
    (
        'Content-Type: application/json'
    );
     
    $ch = curl_init();
    curl_setopt( $ch,CURLOPT_URL, $service_url );
    curl_setopt( $ch,CURLOPT_HTTPGET, true );
    curl_setopt( $ch,CURLOPT_HTTPHEADER, $headers );
    curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
    curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
    $result = curl_exec($ch );
    curl_close( $ch );
    while (true) {
        //echo "retry: 1000" . PHP_EOL;
        echo 'id: ' . uniqid() . PHP_EOL;
        echo 'data: ' . $result . PHP_EOL;
        echo PHP_EOL;
        //ob_flush();
        //flush();
        sleep(1);
        
        return $response->withHeader('Content-Type', 'text/event-stream');
    }

    
});

// get all evenements
$app->get('/evenements', function ($request, $response, $args) {
    $sth = $this->db->prepare("SELECT * FROM evenements ORDER BY dateCreation");
    $sth->execute();
    $events = $sth->fetchAll();
    return $this->response->withJson($events);
});

// get evenement by id
$app->get('/evenement/[{id}]', function ($request, $response, $args) {
    $sth = $this->db->prepare("SELECT * FROM evenements WHERE id=:id");
    $sth->bindParam("id", $args['id']);
    $sth->execute();
    $events = $sth->fetchObject();
    return $this->response->withJson($events);
});

// get evenement by groupName
$app->get('/evenements/group/[{group}]', function ($request, $response, $args) {
    
    $sth = $this->db->prepare("SELECT * FROM evenements WHERE groupName=:groupName ORDER BY dateCreation DESC");
    $sth->bindParam("groupName", $args['group']);
    $sth->execute();
    $events = $sth->fetchAll();
    return $this->response->withJson($events);
});

/*get last event insert*/
$app->get('/evenement/group/[{group}]', function ($request, $response, $args) {
    
    $sth = $this->db->prepare("SELECT * FROM evenements WHERE groupName=:groupName and id = (select max(id)
    FROM evenements WHERE groupName=:groupName GROUP BY id ORDER BY dateCreation DESC LIMIT 1) ");
    $sth->bindParam("groupName", $args['group']);
    $sth->execute();
    $events = $sth->fetchAll();
    return $this->response->withJson($events);
});

// get evenement ordres
$app->get('/evenement/ordres/[{id}]', function ($request, $response, $args) {
    $sth = $this->db->prepare("SELECT * FROM evenements WHERE ordre= 1");
    $sth->execute();
    $events = $sth->fetchAll();
    return $this->response->withJson($events);
});

// get evenement alertes
$app->get('/evenement/alertes/[{id}]', function ($request, $response, $args) {
    $sth = $this->db->prepare("SELECT * FROM evenements WHERE alerte= 1");
    $sth->execute();
    $events = $sth->fetchAll();
    return $this->response->withJson($events);
});

// DELETE a events with given id
$app->delete('/evenement/[{id}]', function ($request, $response, $args) {
    $sth = $this->db->prepare("DELETE FROM evenements WHERE id=:id");
    $sth->bindParam("id", $args['id']);
    if ($sth->execute())
    return $this->response->withJson(array("status" => "success", "code" => 200));
return $this->response->withJson(array("status" => "error", "code" => 404));
});

//ajouter Event
$app->post('/evenements', function ($request, $response) {
    $input = $request->getParsedBody();
    $ordre = ($input['ordre'] == 'true')? 1 : 0;
    $alert = ($input['alert'] == 'true')? 1 : 0;
    $sitacLien = $input['eventName'].'_'. $input['groupName'];

    $sth = $this->db->prepare("INSERT INTO evenements (nom, 
    groupName, 
    alerte, 
    ordre, 
    lieu, 
     idUsersCreate,
      sitacLien,
      description,
      roomId,
      roomAlias) VALUES (:nom,:groupName,:alerte, :ordre, :lieu, :idUserCreate,:sitacLien, :description, :roomId, :roomAlias )");
      
    $sth->bindParam("nom", $input['eventName']);
    $sth->bindParam("groupName", $input['groupName']);
    $sth->bindParam("alerte", $alert);
    $sth->bindParam("ordre", $ordre);
    $sth->bindParam("lieu", $input['eventPlace']);
    $sth->bindParam("idUserCreate", $input['idCurrentUser']);
    $sth->bindParam("sitacLien", $sitacLien);
    $sth->bindParam("description", $input['description']);
    $sth->bindParam("roomId", $input['roomId']);
    $sth->bindParam("roomAlias", $input['roomAlias']);
    if ($sth->execute())
        return $this->response->withJson(array("status" => "success", "code" => 200));
    return $this->response->withJson(array("status" => "error", "code" => 500));
   
});

/* update events */
$app->post('/evenements/[{id}]', function ($request, $response, $args) {
    try 
    {
        $input = $request->getParsedBody();
        $ordre = ($input['status'] == 'ordre')? 1 : 0;
        $alert = ($input['status'] == 'alerte')? 1 : 0;
        $sitacLien = $input['nom'].'_'. $input['groupName'];
        $tmp = null;
        $tmp1 = intval($args['id']);

        $sth = $this->db->prepare("UPDATE evenements SET nom =:nom, 
        groupName =:groupName, 
        dateDebut =:dateDebut,
        dateFin =:dateFin,
        alerte =:alerte, 
        ordre =:ordre, 
        lieu =:lieu, 
        idUsersCreate =:idUsersCreate,
        sitacLien =:sitacLien  WHERE id =:id");
        
        $sth->bindParam("id",  $tmp1);
        $sth->bindParam("nom", $input['nom']);
        $sth->bindParam("groupName", $input['groupName']);
        $sth->bindParam("dateDebut", $tmp);
        $sth->bindParam("dateFin", $tmp);
        $sth->bindParam("alerte", $alert);
        $sth->bindParam("ordre", $ordre);
        $sth->bindParam("lieu", $input['lieu']);
        $sth->bindParam("idUsersCreate", $input['idCurrentUser']);
        $sth->bindParam("sitacLien", $sitacLien);
        if ($sth->execute()){
            return $this->response->withJson(array("status" => "success", "code" => 1));
        }
        return $this->response->withJson(array("status" => "error", "code" => 0));
    } catch(PDOException $e) {
        echo '{"error":{"text":'. $e->getMessage() .'}}';
    }

   /* $app->post('/messages/messageImportant/', function ($request, $response, $args) {
        try 
        {
            $input = $request->getParsedBody();
            $ordre = ($input['status'] == 'ORDRE!')? 1 : 0;
            $alert = ($input['status'] == 'ALERTE')? 1 : 0;
            $sitacLien = $input['nom'].'_'. $input['groupName'];
            $tmp = null;
            $tmp1 = intval($args['id']);
    
            $sth = $this->db->prepare("UPDATE evenements SET nom =:nom, 
            groupName =:groupName, 
            dateDebut =:dateDebut,
            dateFin =:dateFin,
            alerte =:alerte, 
            ordre =:ordre, 
            lieu =:lieu, 
            idUsersCreate =:idUsersCreate,
            sitacLien =:sitacLien  WHERE id =:id");


            
            $sth->bindParam("id",  $tmp1);
            $sth->bindParam("nom", $input['nom']);
            $sth->bindParam("groupName", $input['groupName']);
            $sth->bindParam("dateDebut", $tmp);
            $sth->bindParam("dateFin", $tmp);
            $sth->bindParam("alerte", $alert);
            $sth->bindParam("ordre", $ordre);
            $sth->bindParam("lieu", $input['lieu']);
            $sth->bindParam("idUsersCreate", $input['idCurrentUser']);
            $sth->bindParam("sitacLien", $sitacLien);
            if ($sth->execute()){
                return $this->response->withJson(array("status" => "success", "code" => 1));
            }
            return $this->response->withJson(array("status" => "error", "code" => 0));
        } catch(PDOException $e) {
            echo '{"error":{"text":'. $e->getMessage() .'}}';
        }
        */
   
});




