import { Component } from '@angular/core';
import {NavController, Loading, AlertController, LoadingController} from 'ionic-angular';
import {AuthService} from '../../providers/auth-service';
import {HomePage} from "../home/home";
import {LocalStorage} from "../../providers/localStorage";
import {UserService} from "../../providers/user-service";



/**
 * Generated class for the LoginPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */

@Component({
  selector: 'page-login',
  templateUrl: 'login.html',
})
export class LoginPage {

  loading: Loading;
  registerCredentials = {"email" : "", "password": ""};
  data: any;


  constructor(public navCtrl: NavController, private auth: AuthService,
              private alertCtrl : AlertController, private loadingCtrl: LoadingController, private storage:LocalStorage, public user: UserService) {


  }


  /*public login(){
    this.showLoading();

    this.auth.login(this.registerCredentials).subscribe(allowed => {
      if (allowed){
          console.log('Login email '+this.registerCredentials.email);
        this.storage.setEmail(this.registerCredentials.email);
          console.log('Login Storage email '+this.storage.getEmail() );
        this.navCtrl.setRoot(HomePage);
      }
      else{
        this.showError("Access Denied");
      }
    },
        error =>{
          this.showError(error)
        });

  }*/

  public login(){
    this.showLoading();

    this.auth.login(this.registerCredentials).then(result => {
      this.data = result;
      console.log('allowed'+ this.data);
      if (this.data.status !== 'error'){
        this.user.addUser({name:this.data.name, email:this.data.email,
        grade:this.data.grade, apikey:this.data.apiKey, senderId:this.data.senderId,  groupname: this.data.groupname});

        console.log('allowed'+ this.data.apiKey);
          console.log('Login email '+this.registerCredentials.email);
        this.storage.setEmail(this.registerCredentials.email);
          console.log('Login Storage email '+this.storage.getEmail() );
       this.navCtrl.setRoot(HomePage);
      }
      else{
        this.showError("Access Denied");
      }
    },
        (err) =>{
          this.showError(err)
        });

  }

  showLoading(){
    this.loading = this.loadingCtrl.create({
        content: 'Please wait...',
        dismissOnPageChange : true
    });
    this.loading.present();
  }

  showError(text){
    this.loading.dismiss();
    let alert = this.alertCtrl.create({
        title: 'Fail',
        subTitle: text,
        buttons: ['OK']
    });
    alert.present(prompt);
  }


  ionViewDidLoad() {
    console.log('ionViewDidLoad LoginPage');
  }

}
