import { Component, ElementRef } from '@angular/core';
import { IonicPage, Loading, NavController, NavParams, LoadingController} from 'ionic-angular';
import { Observable } from 'rxjs';
import {Http} from '@angular/http';
import {Chat, Message} from '../../app/model/chat.model';
import {MatrixService} from '../../providers/matrix-service';
import {LocalStorage} from '../../providers/localStorage';
import 'rxjs/add/operator/merge'

/**
 * Generated class for the MessageTchatPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */
/*@Todo scrol message and limit message at 30*/

@IonicPage()
@Component({
  selector: 'page-message-tchat',
  templateUrl: 'message-tchat.html',

})
export class MessageTchatPage {
  listMessage : Message[]=[];
  loading: Loading;
  listEventId: any[] = [];
  selectedChat: Chat;
  title: string;
  picture: string;
  messages: Observable<Message[]>;
  messagesResult: Message[]=[];
  message: string = '';
  data: any;
  test : string;
  sender: string;
  autoScroller: MutationObserver;
  scrollOffset = 0;
  //@TODO add in the local storage  where in matrix service
  prev_event_id: string;
  statusMessage : boolean;
  statusMessages : any;
  fixedTimezone : any;
  today: any;

  constructor(public navCtrl: NavController, public navParams: NavParams, public matrix: MatrixService, public httpModule: Http,
    public storage: LocalStorage,private loadingCtrl: LoadingController, private el: ElementRef) {
    this.selectedChat = <Chat>navParams.get('chat');

    this.title = this.selectedChat.nom;
    this.picture = this.selectedChat.picture;
    this.storage.getUser().then(result=>{
      this.sender = result.senderId;
      console.log("SENDER"+result.senderId);
     } );
     /** Init event id  */
     this.storage.getEventId().then(result=>{
      console.log('fgtyh '+result)
      if (result)
        this.prev_event_id = result.eventId;

     })
     /*streaming data for new message*/
     this.matrix.stremingChat().subscribe(res =>{

       if (this.prev_event_id !== res[0].event_id && this.sender !== res[0].sender ){
          this.listMessage.push(res);
          console.log("stremaing")
         console.log(res);
          var statusMessage = this.isAlerteOrOdre(res[0].content.body);
          if(statusMessage !== 'false'){
            res[0]['status'] = statusMessage;
            if (statusMessage === "ALERTE!")
               this.storage.setMessageAlert(res[0]);
            else if (statusMessage === "ORDRE!")
              this.storage.setMessageOrdre(res[0]);
          }
          this.displayNotificationStatusMessage(res[0].content.body);
          this.prev_event_id = res[0].event_id
         console.log("stremaing"+ this.prev_event_id)
       }

     })
  }


  ionViewDidLoad() {
    this.autoScroller = this.autoScroll();
    this.setHistoryEvents();

    console.log('ionViewDidLoad MessageTchatPage'+this.messages);
  }

  public setHistoryEvents(){
    this.showLoading();
    /*this.matrix.syncChat().subscribe(
      (data)=> {
        console.log("dada");
        console.log(data.join[this.matrix.getRoomId()].timeline.events[0].content)
        this.messages = data.join[this.matrix.getRoomId()].timeline.events;
      },
      (error) => console.log("error : " + error)
    )*/

    this.messages = this.matrix.syncChat();
    console.log("messageGTGHHHH")
    console.log(this.messages);
  }


  showLoading(){
    this.loading = this.loadingCtrl.create({
        content: 'Please wait...',
        dismissOnPageChange : true
    });
    this.loading.present();
  }

  public setRecentEvent(statusMessage:string){

    this.matrix.recentEvent().subscribe(res =>  {
      console.log("setRecentEvent")
      console.log(res[this.matrix.getRoomId()].timeline.events)
      this.listMessage.push(res[this.matrix.getRoomId()].timeline.events);
      if(statusMessage !== 'false'){
        res[this.matrix.getRoomId()].timeline.events[0]['status'] = statusMessage;
        if (statusMessage === "ALERTE!")
           this.storage.setMessageAlert(res[this.matrix.getRoomId()].timeline.events[0]);
        else if (statusMessage === "ORDRE!")
          this.storage.setMessageOrdre(res[this.matrix.getRoomId()].timeline.events[0]);
      }

      this.storage.setEventId(res[this.matrix.getRoomId()].timeline.events[0].event_id);});
    //this.message="";
  }


 public  onInputKeypress({ keyCode }: KeyboardEvent): void {
    if (keyCode === 13) {
      this.sendTextMessage();
    }
  }

  public sendTextMessage(): void {
    // If message was yet to be typed, abort
    if (!this.message) {
      return;
    }
    this.data = {"msgtype":"m.text", "body":this.message};
    this.today = Date.now();
    this.fixedTimezone = '2015-06-15T09:03:01+0900';
    this.displayNotificationStatusMessage(this.message);
    this.matrix.sendChat(this.data).then(res=>{this.setRecentEvent(this.isAlerteOrOdre(this.message));this.message = '';})

  }

  displayNotificationStatusMessage(message : string){
    console.log( this.isAlerteOrOdre(message) + ' ' +message )
    if (this.isAlerteOrOdre(message) !== 'false')
    this.statusMessages = {'status': this.isAlerteOrOdre(message), 'body': this.isAlerteOrOdre(message) == 'ALERTE!'? message.replace('@alert', ''):message.replace('@ordre', '')};
    console.log('statusMessage'+this.statusMessages);
  }

  public isAlerteOrOdre(message : string): string{
    if (message){
      if (message.search("@alert") > -1){
        return "ALERTE!";
      }
     else if (message.search("@ordre") > -1){
        return "ORDRE!";
      }
      else
        return 'false';
    }
    return 'false';

  }
  convertirSeconde(sec : number){
    var hour   = (((sec / 60) / 60) % 24);
    var min  = ((sec / 60 ) % 60);
    var seconde = sec % 60;
    return (Math.trunc(hour) > 0) ? Math.trunc(hour)+'h'+Math.trunc(min)+'m'+Math.trunc(seconde)+'s'
                                :(Math.trunc(min) > 0) ? Math.trunc(min)+'m'+Math.trunc(seconde)+'s'
                                            : Math.trunc(seconde)+'s';
  }


  /**scroll */
  private get messagesPageContent(): Element {
    return this.el.nativeElement.querySelector('.messages-page-content');
  }

  private get messagesList(): Element {
    return this.messagesPageContent.querySelector('.messages');
  }

  private get scroller(): Element {
    return this.messagesList.querySelector('.scroll-content');
  }
  ngOnDestroy() {
    this.autoScroller.disconnect();
  }

  autoScroll(): MutationObserver {
    const autoScroller = new MutationObserver(this.scrollDown.bind(this));

    autoScroller.observe(this.messagesList, {
      childList: true,
      subtree: true
    });

    return autoScroller;
  }


  scrollDown(): void {
    // Scroll down and apply specified offset
    this.scroller.scrollTop = this.scroller.scrollHeight - this.scrollOffset;
    // Zero offset for next invocation
    this.scrollOffset = 0;
  }


}
