import {Component} from '@angular/core';
import 'rxjs/add/operator/map'
import {IonicPage, NavController} from "ionic-angular";
import {Geolocation} from "@ionic-native/geolocation";
import {UserModel} from "../../app/model/user.model";
import {LocalStorage} from "../../providers/localStorage";

/**
 * Generated class for the ProfilPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */


@IonicPage()
@Component({
  selector: 'page-profil',
  templateUrl: 'profil.html',
})
export class ProfilPage {
    zoom: number = 15;
    lat: number;
    lng: number;
    editMyNumber: boolean = false;
    myInfos : UserModel[] = [];
  constructor(public navCtrl: NavController, public geolocation: Geolocation, public storage:LocalStorage) {
    this.lat = 51.678418;
    this.lng = 7.809007;
  }

    ionViewDidLoad() {
        console.log('ionViewDidLoad ProfilPage');
        this.loadInfo();
        console.log(this.myInfos);
        this.loadMap();
    }

    loadInfo(){
      this.storage.getUser().then(result=>{
          console.log(result)
          this.myInfos = result;
      })

    }

    loadMap(){
        this.geolocation.getCurrentPosition().then((position) =>{
            console.log("location fetched successfully");
            this.lat = position.coords.latitude ;
            this.lng = position.coords.longitude;


        }, (err) =>{
            console.log(err);
        });
    }
    editNumber(){
        this.editMyNumber = true;
    }
    cancelNumber(){
        this.editMyNumber = false;
        console.log("ici");

    }
}
