import { Component } from '@angular/core';
import { IonicPage, NavController, NavParams } from 'ionic-angular';
import { Observable } from 'rxjs';
import {Chat} from '../../app/model/chat.model';
import {MatrixService} from '../../providers/matrix-service';
import {MessageTchatPage} from '../message-tchat/message-tchat';
import {LocalStorage} from '../../providers/localStorage';

/**
 * Generated class for the TchatPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */

@IonicPage()
@Component({
  selector: 'page-tchat',
  templateUrl: 'tchat.html',
})
export class TchatPage {

  chats: Observable<Chat[]>;
  apikeyCurrentUser : string;

  constructor(public navCtrl: NavController, public navParams: NavParams, public matrix: MatrixService, public storage:LocalStorage) {
    this.storage.getUser().then(result=>{
      this.apikeyCurrentUser = result.apikey;
      console.log("constructor"+result.apikey);
     } );
  }



  ionViewDidLoad() {
    this.storage.getUser().then(result=>{
      this.chats = this.matrix.listEventRoom(result.groupname)
      this.apikeyCurrentUser = result.apikey;
      console.log("constructor"+result.apikey);
      console.log(this.chats);
     } );
   
    console.log('ionViewDidLoad TchatPage');
  }

  showMessages(chat, apiKey: string): void {
    console.log("showMessage"+apiKey);

    this.matrix.setRoomId(chat.roomId);
    this.matrix.setApiKey(apiKey);
    this.matrix.joinChat();
    this.navCtrl.push(MessageTchatPage, {chat});
  }

}
