import {ElementRef, Injectable, ViewChild} from "@angular/core";

import {Geolocation} from "@ionic-native/geolocation";

declare var google

@Injectable()
export class GoogleMaps{

    @ViewChild('map') mapElement: ElementRef
    map: any;

    constructor(public geolocation: Geolocation){

    }


    loadMap(){
        this.geolocation.getCurrentPosition().then((position) =>{

        let latLng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);

        let mapOptions = {
            center: latLng,
            zoom:15,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        }

        this.map = new google.maps.Map(this.mapElement.nativeElement, mapOptions);
    }, (err) =>{
            console.log(err);
    });
    }

    addMaker(){
        let marker = new google.maps.Marker({
            map: this.map,
            animation: google.maps.Animation.DROP,
            position: this.map.getCenter()
        });
        let content = "<h4>information</h4>"
        this.addInfoWindow(marker, content)
    }

    addInfoWindow(marker, content){
        let infoWindow = new google.maps.InfoWindow({
            content: content
        })

        google.maps.event.addListener(marker, 'click', ()=>{
            infoWindow.open(this.map, marker);
        })
    }
}