import {Injectable} from "@angular/core";
import {Storage} from "@ionic/storage";
import {UserModel} from "../app/model/user.model";
import {MessageAlert, MessageOrdre} from "../app/model/chat.model";


@Injectable()
export class LocalStorage{

    myInfo: UserModel[] = [];
    constructor(private storage:Storage){

    }

    setEmail(email){
        this.storage.set('email', email)
        console.log('email '+this.getEmail());
    }
    setEventId(eventId: string){
        this.storage.set('eventId', eventId)
        console.log('eventId '+eventId);
    }
    setUser(user:UserModel){
        this.storage.set('user', user)
        console.log('user '+user.email);
    }

    getEmail(){
        return this.storage.get('email')

    }
    getEventId(){
        return this.storage.get('eventId')

    }

    getUser(){
        return this.storage.get('user');

    }
    setMessageOrdre(message:MessageOrdre){
        this.storage.set('messageOrdre', message)
        console.log('message ordre '+message);
    }

    setMessageAlert(message:MessageAlert){
        this.storage.set('messageAlert', message)
        console.log('message alert '+message)
    }


    getMessageOrdre(){
        return this.storage.get('messageOrdre');

    }

    getMessageAlert(){
        return this.storage.get('messageAlert');

    }

    removeEmail(){
        this.storage.remove('email').then(()=>{
            console.log('email is removed')
            this.getEmail().then(email=> {
                console.log('Email' + email)
            })
        })
    }

    clearStorage(){
        this.storage.clear().then(()=>{
            console.log('all keys are cleared')

        })

    }
}
