import { Injectable } from '@angular/core';
import {Http} from '@angular/http';
import {Message} from '../app/model/tchat';
import { Observable } from 'rxjs';


export class MatrixInfo{
  roomId: string;
  roomAlias: string;
    apikey: string;


  constructor(roomId:string, roomAlias:string, apiKey:string){
      this.roomId = roomId;
      this.roomAlias = roomAlias;
      this.apikey = apiKey;
  }
}



@Injectable()
export class MatrixService{
  listMessage : Message[] = [];
  matrixInfo : MatrixInfo;

    apiUrl: string = "https://matrix.org:8448/_matrix/client/r0/"
    /**access token identifier your count  */
    apiKey: string 
    roomId : string 
    urlEvents : string = "http://localhost:8080/donut/api/public/evenements/group/"; 
    roomAlias: string;
    constructor(public httpModule:Http){
      
    }

    initApiMatrix(roomId:string, roomAlias:string, apiKey:string){
          this.matrixInfo = new MatrixInfo(roomId, roomAlias, apiKey)
     }

    setRoomId(roomId: string){
      this.roomId = roomId;
    }
    seRoomAlias(roomAlias: string){
      this.roomAlias = roomAlias;
    }
    setApiKey(apiKey: string){
      this.apiKey = apiKey
    }

    //@TODO list event by user id
    listEventRoom(groupname) {
      return this.httpModule.get(this.urlEvents+groupname).map(res =>res.json());
    }

    sendChat(data){
      return new Promise((resolve, reject) => {
        this.httpModule.post(this.apiUrl+'rooms/'+this.roomId+'/send/m.room.messag?access_token='+this.apiKey,  JSON.stringify(data))
          .subscribe(res => {
            resolve(res);
          }, (err) => {
            reject(err);
          });
      });
    }
getRoomId(): string{
 return this.roomId;
}

    syncChat(){
  
    return this.apiUrl+'sync?access_token='+this.apiKey;
       
    }

    joinChat(){
      return new Promise((resolve, reject) => {
        this.httpModule.post(this.apiUrl+'rooms/'+this.roomId+'/join?access_token='+this.apiKey,  JSON.stringify(''))
          .subscribe(res => {
            resolve(res);
          }, (err) => {
            reject(err);
          });
      });

    }

    recentEvent(){
      return this.httpModule.get(this.apiUrl+'sync?filter={"room":{"timeline":{"limit":1}}}&access_token='+this.apiKey)
      .map(res => res.json().rooms.join[this.roomId].timeline.events)
      
    }

    asyncObservable() {
      return new Observable(observer => {
        setInterval(() => {
          observer.next(this.httpModule.get(this.apiUrl+'sync?filter={"room":{"timeline":{"limit":1}}}&access_token='+this.apiKey));
        }, 1000)
      })
  }

}
